// Macros
// -----------------------------------------------------
// lcdisr.s
// -----------------------------------------------------
.macro lcd4bitout
#ifdef PWMLOOP
	out		LCD_dataport,	r16			//Column Adresse auf Port ausgeben	/ pwm CAS auf high/CP auf low
	inc r16								//Column Adresse + 1				/ pwm CAS auf low
	nop									//									  pwm CP auf high
#else
	out		LCD_com0port,	R_RAS			//RAS Signal
	out		LCD_dataport,	r16				//Column Adresse auf Port ausgeben
	out		LCD_com0port,	R_CAS			//CAS Signal
	inc		r16								//Column Adresse + 1
	out		LCD_com0port,	r19				//CP Signal (LCD)
#endif
.endm
.macro lcd16bitout
	lcd4bitout
	lcd4bitout
	lcd4bitout
	lcd4bitout
.endm
.macro lcd80bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
	lcd16bitout
.endm
.macro lcd320bitout
	lcd80bitout
	lcd80bitout
	lcd80bitout
	lcd80bitout
.endm

// -----------------------------------------------------
// lcdwchar.s
// -----------------------------------------------------

.macro	write_nibbel data	;(a)	// (data)
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	r16			//	CAS+OE
	out		LCD_dataport,	\data		//	Daten auf Port ausgeben
	out		LCD_com0port,	R_CAS_W		//	CAS_W
.endm

// R20 data / r23 Col / r19 out
.macro	charcol_frame0
	clr		r19							// TC / BG color
	sbrc	r23,	3
	or		r19,	r20
	com		r20
	sbrc	r23,	7
	or		r19,	r20
.endm

// R20 data / r23 Col / r19 out
.macro charcol_frame1
	clr		r19							// TC / BG color
	sbrc	r23,	6
	or		r19,	r20
	com		r20
	sbrc	r23,	2
	or		r19,	r20
.endm

// R20 data / r23 Col / r19 out
.macro charcol_frame2
	clr		r19							// TC / BG color
	sbrc	r23,	6
	or		r19,	r20
	com		r20
	sbrc	r23,	2
	or		r19,	r20
.endm

// R21 Col Adresse / r30 temp / r31 read Data
.macro read_nibbel_c
	out		LCD_com0port,	R_RAS		//	RAS	Signal
	sbi		LCD_adport,		RAM_A8		//  DRAM Set A8
	out		LCD_dataport,	r21			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		Drv_dir_port,	Drv_dir		//	B->A
	clr		r30
	out		LCD_dataddr,	r30			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	inc		r21	
	cbi		LCD_adport,		RAM_A8		//  DRAM Clear A8
	ser		r30
	in		r31, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	out		LCD_dataddr,	r30			//	Port als ausgang
	sbi		Drv_dir_port,	Drv_dir		//	A->B		 
	out		LCD_com0port,	r17			//  c_norm
.endm

// -----------------------------------------------------
// lcdcon.s
// -----------------------------------------------------

// r24 Col Adresse / r17 temp / r21 read data
.macro read_nibbel
	out		LCD_com0port,	R_RAS		//	RAS	Signal
	out		LCD_dataport,	r24			//	Col Adresse
	out		LCD_com0port,	R_CAS		//	CAS	Signal
	cbi		Drv_dir_port,	Drv_dir		//	B->A
	clr		r17
	out		LCD_dataddr,	r17			//	Port als eingang
	cbi		LCD_com0port,	Drv_E
	nop
	nop
	ser		r17
	nop
	in		r21, LCD_datapin			//	Daten lesen
	sbi		LCD_com0port,	Drv_E
	out		LCD_dataddr,	r17			//	Port als ausgang
	sbi		Drv_dir_port,	Drv_dir		//  A->B
	sbi		LCD_com0port,	RAM_OE	
	cbi		LCD_com0port,	Drv_E
.endm

.macro	write_nibbel2 data cas	;(a)(b)	// (data)(Cas_oe)
	out		LCD_com0port,	R_RAS_W		//	RAS
	out		LCD_dataport,	r24			//	COL Adresse
	out		LCD_com0port,	\cas		//	CAS+OE
	out		LCD_dataport,	\data		//	Daten auf Port ausgeben
	out		LCD_com0port,	R_CAS_W		//	CAS_W
.endm