#define F_CPU		20000000UL

#define	Framerate	85

#define COMMAND_TIMEOUT	85			// Timeout in Frames
#define	STARTMON					// Startbildschirm anzeigen
#define LCDTouch					// LCD_Touch Routinen aktivieren
#define PWMLOOP						// Hardware ausgabe mit Timer1 von CAS und CP
//#define FASTLOOP					// Geschwindigkeit auf Kosten des Flashverbrauchs erhhen (keine wirkung wenn PWMLOOP aktiv ist)
//#define Touchtest					// Touch test

#define XSIZE		320
#define YSIZE		240

#define XOScan		0
#define YOScan		0

#define	RELOAD		(F_CPU/8/(Framerate*(YSIZE+YOScan)))-1
#define XVSIZEGR	512
#define XVSIZESW	1024

// AD Port
#define		LCD_adport		_SFR_IO_ADDR(PORTA)
#define		LCD_adpin		_SFR_IO_ADDR(PINA)
#define		LCD_adddr		_SFR_IO_ADDR(DDRA)

#define 	T_Xre		2
#define 	T_Xli		0
#define 	T_Yob		3
#define 	T_Yun		1

#define 	JP_0		5
#define		JP_1		6
#define		JP_2		7

#define		RAM_A8_port		_SFR_IO_ADDR(PORTA)
#define 	RAM_A8		4

// DATA Port
#define		LCD_dataport	_SFR_IO_ADDR(PORTC)
#define		LCD_datapin		_SFR_IO_ADDR(PINC)
#define		LCD_dataddr		_SFR_IO_ADDR(DDRC)

// COM0 Port
#define		LCD_com0port	_SFR_IO_ADDR(PORTD)
#define		LCD_com0pin		_SFR_IO_ADDR(PIND)
#define		LCD_com0ddr		_SFR_IO_ADDR(DDRD)

#define 	RAM_RAS		3
#define 	RAM_CAS		4		// wenn PWMLOOP aktiv ist muss LCD_CAS auf Pin 4 Port D Sein
#define 	RAM_OE		7
#define 	RAM_WE		6
#define 	LCD_CP		5		// wenn PWMLOOP aktiv ist muss LCD_CP auf Pin 5 Port D Sein
#define		Drv_E		2

// LCD_LP und Drv_dir
#define 	LCD_LP_port		_SFR_IO_ADDR(PORTB) //B
#define 	LCD_LP		5	//3
#define 	Drv_dir_port	_SFR_IO_ADDR(PORTB) //B
#define		Drv_dir		2	//2

// COM1 Port
#define		LCD_com1port	_SFR_IO_ADDR(PORTB)
#define		LCD_com1pin		_SFR_IO_ADDR(PINB)
#define		LCD_com1ddr		_SFR_IO_ADDR(DDRB)

#define 	LCD_OnOff	0
#define 	LCD_FLM		1
#define 	LCD_LED_PWM	3
//#define 	LCD_Kon_PWM	4			// Nur bei 164/324/644 Verfhgbar
//#define 	LCD_M		7
//#define 	CTS			6			// Achtung in der uart.h auch eintragen

// com0 (LCD_com0port == LCD_LP_port && )
#if (1)
#define		C_norm		((1<<RAM_WE)|(1<<RAM_OE)|(1<<RAM_CAS)|(1<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))
#define		C_RAS		((1<<RAM_WE)|(0<<RAM_OE)|(1<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))
#define		C_CAS		((1<<RAM_WE)|(0<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))
#define		C_CP		((1<<RAM_WE)|(0<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(1<<LCD_CP)|(1<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))
#define		C_RAS_W		((1<<RAM_WE)|(1<<RAM_OE)|(1<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))
#define		C_CAS_OE	((1<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))
#define		C_CAS_W		((0<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))
#define		C_CAS_OECLR	((1<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))
#define		C_CAS_WCLR	((0<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E))//|(0<<LCD_LP2)|(1<<Drv_dir))

#else

#define		C_norm		((1<<RAM_WE)|(1<<RAM_OE)|(1<<RAM_CAS)|(1<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))
#define		C_RAS		((1<<RAM_WE)|(0<<RAM_OE)|(1<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))
#define		C_CAS		((1<<RAM_WE)|(0<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))
#define		C_CP		((1<<RAM_WE)|(0<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(1<<LCD_CP)|(1<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))
#define		C_RAS_W		((1<<RAM_WE)|(1<<RAM_OE)|(1<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))
#define		C_CAS_OE	((1<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))
#define		C_CAS_W		((0<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(0<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))
#define		C_CAS_OECLR	((1<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))
#define		C_CAS_WCLR	((0<<RAM_WE)|(1<<RAM_OE)|(0<<RAM_CAS)|(0<<RAM_RAS)|(0<<LCD_CP)|(1<<Drv_E)|(0<<LCD_LP)|(1<<Drv_dir))

#endif

// AD Port
#define		AD_P_noTouch	((0<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(1<<JP_0)|(1<<JP_1)|(1<<JP_2)|(0<<RAM_A8))
#define		AD_D_noTouch	((0<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(0<<JP_0)|(0<<JP_1)|(0<<JP_2)|(1<<RAM_A8))

#define		AD_P_Touch_XY	((1<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(1<<JP_0)|(1<<JP_1)|(1<<JP_2)|(0<<RAM_A8))
#define		AD_D_Touch_XY	((0<<T_Xre)|(0<<T_Xli)|(1<<T_Yob)|(0<<T_Yun)|(0<<JP_0)|(0<<JP_1)|(0<<JP_2)|(1<<RAM_A8))

#define		AD_P_Touch_X	((1<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(1<<JP_0)|(1<<JP_1)|(1<<JP_2)|(0<<RAM_A8))
#define		AD_D_Touch_X	((1<<T_Xre)|(1<<T_Xli)|(0<<T_Yob)|(0<<T_Yun)|(0<<JP_0)|(0<<JP_1)|(0<<JP_2)|(1<<RAM_A8))

#define		AD_P_Touch_Y	((0<<T_Xre)|(0<<T_Xli)|(0<<T_Yob)|(1<<T_Yun)|(1<<JP_0)|(1<<JP_1)|(1<<JP_2)|(0<<RAM_A8))
#define		AD_D_Touch_Y	((0<<T_Xre)|(0<<T_Xli)|(1<<T_Yob)|(1<<T_Yun)|(0<<JP_0)|(0<<JP_1)|(0<<JP_2)|(1<<RAM_A8))

#if defined(__AVR_ATmega16__) || defined(__AVR_ATmega164A__) || defined(__AVR_ATmega164P__) || defined(__AVR_ATmega164PA__)
#define flashsize 16
#define fontcount 3
#elif defined(__AVR_ATmega32__) || defined(__AVR_ATmega324A__) || defined(__AVR_ATmega324P__) || defined(__AVR_ATmega324PA__)
#define flashsize 32
#define fontcount 5
#define font1624max	195
#elif defined(__AVR_ATmega644__) || defined(__AVR_ATmega644A__) || defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644PA__)
#define flashsize 64
#define fontcount 6
#define font1624max	200
#else
#error Not Supportet Microcontroller
#endif

// MC ist ein xx4 Type
#if defined(__AVR_ATmega644__) || defined(__AVR_ATmega644A__) || defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644PA__) || defined(__AVR_ATmega644PA__) ||	\
defined(__AVR_ATmega324A__) || defined(__AVR_ATmega324P__) || defined(__AVR_ATmega324PA__) ||										\
defined(__AVR_ATmega164A__) || defined(__AVR_ATmega164P__) || defined(__AVR_ATmega164PA__)				
#define megaXX4
#endif